# Copyright (C) 2007 Kris Maglione
# See PERMISSIONS

module R9P
	class Qid <Serial
		module Constants
			QTFILE = 0x00
			QTLINK = 0x01
			QTSYMLINK = 0x02
			QTTMP = 0x04
			QTAUTH = 0x08
			QTMOUNT = 0x10
			QTEXCL = 0x20
			QTAPPEND = 0x40
			QTDIR = 0x80
		end
		include Constants

		class Type <Serial
			field :type, :byte

			alias to_i type

			def to_s
				const = Qid.constants.grep(/^QT/)
				const.collect! { |c|
					v = Qid.const_get(c)
					if type&v == v
						c
					end
				}
				const.reject! {|i| i == nil}
				const.join '|'
			end
		end

		field :type, Type
		field :vers, :dword
		field :path, :qword

		def to_s
			"type: #{type} vers: #{vers} path: #{path}"
		end
	end
end
