# Copyright (C) 2007 Kris Maglione
# See PERMISSIONS

module R9P
	class Stat <Serial
		module Constants
			DMDIR		=0x80000000
			DMAPPEND	=0x40000000
			DMEXCL		=0x20000000
			DMMOUNT		=0x10000000
			DMAUTH		=0x08000000
			DMTMP		=0x04000000
			DMSYMLINK	=0x02000000
			DMDEVICE	=0x00800000
			DMNAMEDPIPE	=0x00200000
			DMSOCKET	=0x00100000
			DMSETUID	=0x00080000
			DMSETGID	=0x00040000
		end
		include Constants

		class Mode <Serial
			field :mode, :dword
			alias_method :to_i, :mode
			def to_s
				modes = 'rwxrwxrwx'
				0.upto(8) { |i|
					if mode&(1 << i) == 0
						modes[-i-1] = '-'
					end
				}
				if mode&Stat::DMDIR > 0
					'd'
				elsif mode&Stat::DMAPPEND > 0
					'a'
				else
					'-'
				end + modes
			end
		end

		field :size, :word, :size, 2
		field :type, :word
		field :dev, :dword
		field :qid, Qid
		field :mode, Mode
		field :atime, :dword
		field :atime, :dword
		field :length, :qword
		field :name, :word, :string
		field :uid, :word, :string
		field :gid, :word, :string
		field :muid, :word, :string

		def self.from_data(data)
			list = []
			while data.length > 0
				list << new(data)
			end
			list
		end
	end
end
